import { URI } from '@stoplight/uri/lib/uri';
import * as Types from './types';
export declare class ResolveRunner implements Types.IResolveRunner {
    readonly id: number;
    depth: number;
    authorityStack: string[];
    readonly authority: URI;
    readonly authorityCache: Types.ICache;
    readonly readers: {
        [scheme: string]: Types.IReader;
    };
    readonly parseAuthorityResult?: (opts: Types.IParseAuthorityOpts) => Promise<Types.IParseAuthorityResult>;
    readonly debug: boolean;
    readonly resolvePointers: boolean;
    readonly resolveAuthorities: boolean;
    readonly transformRef?: (opts: Types.ITransformRefOpts, ctx: any) => URI | any;
    ctx: any;
    private _source;
    constructor(source: any, opts?: Types.IResolveRunnerOpts);
    readonly source: any;
    resolve(jsonPointer?: string): Promise<Types.IResolveResult>;
    /**
     * Determine if we should resolve this part of source
     * If so, return the appropriate URI object
     */
    computeRef: (opts: Types.IComputeRefOpts) => void | URI;
    atMaxAuthorityDepth: () => boolean;
    lookupAuthority: (opts: {
        ref: URI;
        cacheKey: string;
    }) => Promise<ResolveRunner>;
    lookupAndResolveAuthority: (opts: Types.IRefHandlerOpts) => Promise<Types.IAuthorityLookupResult>;
    _cacheKeySerializer(sOpts: any): any;
    private computeAuthorityCacheKey;
}
